public class Example {
	public static void main(String[] args) {
		LeftOrRight leftOrRight = new LeftOrRight(new LeftValue("Hello, world!"));

		try {
			leftOrRight.get();
		} catch (LeftValue l) {
			System.err.println("Got left: " + l.getValue());
		} catch (RightValue r) {
			System.err.println("Got right: " + r.getValue());
		}
	}

	public static class LeftOrRight {
		private LeftValue left = null;
		private RightValue right = null;
		public LeftOrRight(LeftValue left) {
			this.left = left;
		}
		public LeftOrRight(RightValue right) {
			this.right = right;
		}
		public void get() throws LeftValue, RightValue {
			if (left == null) {
				throw right;
			} else {
				throw left;
			}
		}
	}

	private static class ThrowableValue extends Throwable {
		private Object value;
		public ThrowableValue(Object value) {
			this.value = value;
		}
		public Object getValue() {
			return this.value;
		}
	}

	public static class LeftValue extends ThrowableValue {
		public LeftValue(Object value) {
			super(value);
		}
	}
	public static class RightValue extends ThrowableValue {
		public RightValue(Object value) {
			super(value);
		}
	}

}

